﻿/**
 * 
 */

function initialise(){
    showAppTitle();
	if(!eventsInitialised){
	    initialiseEvents();
	    eventsInitialised=true;
	}
	$('body').on('paste input','[contenteditable]',function() {
		userOutputVisible=false;
		$("#studentResults").hide();
		clearHint();
		hideHint();
		hideResult();
		$("#btnPlay").prop("disabled",true);
		$("#btnStop").prop("disabled",true);
		$("#btnForward").prop("disabled",true);
		sizeDIVs();
	});

	simulationReset();
	hintLevel=-1;
	generateDifficultyLevels();
	defineExerciseTypes();
	$("#btnHint").prop("disabled",true);
	$("#btnPlay").prop("disabled",true);
	$("#btnStop").prop("disabled",true);
	$("#btnForward").prop("disabled",true);
    $("#messageArea").hide();
    $("#resultsArea").hide();
	clearCodeResults();
	generateExerciseVariation();
	assembleCode();
	hideSimulationValues();
	if(!helpShown){
		helpShown=true;
		window.location.href="#openModalHelp";
	}
}

function initialiseEvents(){
    $("#btnHelp").on("click touchstart",function(){
    	showHelp();
    	//window.location.href="#openModalHelp";
    });
	
    $("#btnNewProblem").on("click touchstart",function(){
    	initialise();
    });
    
    $("#btnDelete").on("click touchstart",function(){
    	deleteAll();
    });
    
    $("#btnPlay").on("click touchstart",function(){
    	simulateCode();
    });
    
    $("#btnPause").on("click touchstart",function(){
        $("#showOptions").show();
        //simulating=false;
        $("#btnPause").hide();
        $("#btnContinue").show();
        $("#btnForward").prop("disabled",false);
        clearInterval(timerLoop);
        //handleContinuationButtons();
    });
    
    $("#btnContinue").on("click touchstart",function(){
        $("#showOptions").hide();
        //simulating=true;
        $("#btnContinue").hide();
        $("#btnForward").prop("disabled",true);
        $("#btnPause").show();
        timerLoop=setInterval(function(){simulationRun();},simSpeed);
    });
    
    $("#btnStop").on("click touchstart",function(){
        simulationReset();
    });
    
    $("#btnSubmit").on("click touchstart",function(){
    	checkSolution();
    });

    $("#btnShowSolution").on("click touchstart",function(){
    	showSolution();
    });

    $("#btnHint").on("click touchstart",function(){
    	showHint();
    });
    
    $("#btnForward").on("click touchstart",function(){
        /*simulationAborted=false;*/
        if(!simulationInitialised){
            simulationInitialise();
        }
        simulationRun();
        if(simulationIndex==codeLength){
            simulationReset();
        }

    });
    
    $("#closeTool").on("click touchstart",function(){
        hideHelp();
    });
    
    //Κουμπιά διαχείρισης εφαρμογής
    $("#slideSpeed").bind("change keyup touchend",function(event,ui) {
        var maxSimSpeed=Number($(this).attr("max"))+1;
        simSpeed=maxSimSpeed-$(this).val();
    });
    
    $("#showVarValues").bind("change keyup touchend",function(event,ui) {
        if($("#showVarValues:checked").val()=="show"){
            showVarValues=true;
        }
        else{
            showVarValues=false;
        }
    });
    
    $("#requestConfirmations").bind("change keyup touchend",function(event,ui) {
        if($("#requestConfirmations:checked").val()=="reqConfirm"){
            requestConfirmationState=requestConfirmation;
        }
        else{
            requestConfirmationState=dontRequestConfirmation;
        }
    });
    
    $("#showFullSimulationPath").bind("change keyup touchend",function(event,ui) {
        if($("#showFullSimulationPath:checked").val()=="showFullSimPath"){
            hideSimulationPath=false;
        }
        else{
            hideSimulationPath=true;
        }
    });
}

function clearCodeResults(){
	solutionOutputVisible=false;
	$("#originalResults").hide();
	userOutputVisible=false;
	$("#studentResults").hide();
	$("#solutionOk").hide();
	$("#solutionError").hide();
}

function sizeDIVs(){
	var divBorder=15;
	
	var newTop=document.getElementById("studentCodeDIV").getBoundingClientRect().top;
	var studentCodeLeft=divBorder;
	$("#studentCodeDIV").css({
        left: studentCodeLeft+"px"
    });

	var solutionResultsLeft=studentCodeLeft+document.getElementById("studentCodeDIV").getBoundingClientRect().width+divBorder;
	$("#solutionResultsDIV").css({
        top: newTop+"px",
        left: solutionResultsLeft+"px",
        width: "42px"
    });
	
    //Μηνύματα
    var messageAreaLeft=solutionResultsLeft+document.getElementById("solutionResultsDIV").getBoundingClientRect().width+divBorder;
    $("#messageArea").css({
        left: messageAreaLeft+"px"
    });
    //var messageAreaHeight=document.getElementById("studentResults").getBoundingClientRect().height;
    $("#messageArea").css({
        //height: Math.max(messageAreaHeight,30)+"px"
        height: height+"px"
    });
	
	var height=document.getElementById("studentCodeDIV").getBoundingClientRect().height+divBorder;
	$("#exerciseArea").css({
        height: height+"px"
    });

    //Αποτελέσματα
    //var resultsAreaLeft=studentCodeLeft;
    $("#resultsArea").css({
        left: messageAreaLeft+"px"
    });
    //var resultsHeight=document.getElementById("studentResults").getBoundingClientRect().height;
    $("#resultsArea").css({
        //height: Math.max(resultsHeight,30)+"px"
        height: height+"px"
    });
}

function assembleCode(){
	var exerciseCode=generateForLoop();
	document.getElementById("studentCode").innerHTML=exerciseCode;
	sizeDIVs();
}

function generateDifficultyLevels(){
	var menuEntry="<div tabindex='0' class='onclick-menu'>";
	menuEntry+="<ul class='onclick-menu-content'>";
	for(var i=0;i<10;i++){
		menuEntry+="<li><button onclick='setLevel("+i+")'>Επίπεδο "+(i+1)+"</button></li>";
	}
	menuEntry+="</ul>";
	menuEntry+="</div>";
	document.getElementById("levels").innerHTML=menuEntry;
}

function setLevel(selected){
	//Η difficultyLevel παίρνει τιμή selected-1 αφού η generateExerciseVariation() θα την αυξήσει
	difficultyLevel=selected-1;
	initialise();
}

function generateEntryPlaceholder(entryID){
	var newEntry="<span class='toChange' id='"+entryID+"' contenteditable='true'>ˍˍˍ</span>";
	return newEntry;
}

function generateExerciseVariation(){
	if(difficultyLevel<9)difficultyLevel++;
	document.getElementById("difficultyLevel").innerHTML="  Επίπεδο δυσκολίας:"+(difficultyLevel+1)+" ";
	generateDifficultyLevels();
	switch(difficultyLevel){
	case 0: //ΜΕΧΡΙ 10
		loopStartFrom=1;
		loopEndTo=10;
		loopStepValue=1;
		xStep=2;
		exerciseVariation=twoVariables+loopTo;
		break;
	case 1: //ΜΕΧΡΙ 9
		loopStartFrom=0;
		loopEndTo=9;
		loopStepValue=1;
		xStep=2;
		exerciseVariation=twoVariables+loopTo;
		break;
	case 2: //ΜΕΧΡΙ 4
		loopStartFrom=-5;
		loopEndTo=4;
		loopStepValue=1;
		xStep=2;
		exerciseVariation=twoVariables+loopTo;
		break;
	case 3: //ΑΠΟ -2
		loopStartFrom=1;
		loopEndTo=10;
		loopStepValue=1;
		xStep=2;
		xStart=-2;
		exerciseVariation=twoVariables+swapLoopBody+request_xStart;
		break;
	case 4://2*i
		iExpression=["2*i","i*2","2*i","i*2"];
		loopStartFrom=0;
		loopEndTo=9;
		loopStepValue=1;
		exerciseVariation=request_OutputExpression;
		break;
	case 5://2*i-2
		iExpression=["2*i-2","2*(i-1)","i*2-2","(i-1)*2"];
		loopStartFrom=1;
		loopEndTo=10;
		loopStepValue=1;
		exerciseVariation=request_OutputExpression;
		break;
	case 6://i MOD 2 = 0
		iConditional="i MOD 2 = 0";
		loopStartFrom=0;
		loopEndTo=18;
		loopStepValue=1;
		exerciseVariation=outputWithConditional+request_OutputConditional;
		break;
	case 7://x <- x + 1
		loopStartFrom=1;
		loopEndTo=19;
		loopStepValue=1;
		xStep=1;
		xStart=0;
		exerciseVariation=twoVariables+outputWithConditional+request_xStep;
		break;
	case 8://ΜΕ_ΒΗΜΑ 2 ... ΓΡΑΨΕ i
		iExpression=["i","i","i","i"];
		loopStepValue=2;
		loopStartFrom=0;
		loopEndTo=18;
		xStep=1;
		exerciseVariation=request_OutputExpression+loopStep+request_loopStep;
		difficultyThreshold=0;
		break;
	case 9:
		if(difficultyThreshold<1){
			difficultyThreshold+=0.1;
		}
		else{
			difficultyThreshold=Math.random();
		}
		generateRandomExercise();
		break;
	}
	if(debug){
		var params="loopStartFrom="+loopStartFrom;
		params+="<p>loopEndTo="+loopEndTo+"</p>";
		params+="<p>loopStepValue="+loopStepValue+"</p>";
		params+="<p>iExpression=["+iExpression[0]+","+iExpression[1]+","+iExpression[2]+","+iExpression[3]+"]</p>";
		params+="<p>xExpression="+xExpression+"</p>";
		params+="<p>xStart="+xStart+"</p>";
		document.getElementById("prompt").innerHTML=params;
	}
}

function generateRandomExercise(){
	var blanksCounter=0;
	exerciseVariation=0;
	if(Math.random()<difficultyThreshold){//Χρήση δύο μεταβλητών
		exerciseVariation+=twoVariables;
		xStart=2*parseInt((Math.random()-0.5)*10);
		if(Math.random()<difficultyThreshold){//εισαγωγή αρχικής τιμής x
			exerciseVariation+=request_xStart;
			blanksCounter++;
		}
		if(Math.random()<difficultyThreshold){
			xStep=2;
		}
		else{
			xStep=1;
		}
		if(Math.random()<difficultyThreshold){//εισαγωγή μεταβολής x
			exerciseVariation+=request_xStep;
			blanksCounter++;
		}
		if(Math.random()<difficultyThreshold){//σειρά εντολών στο σώμα της Δομής
			exerciseVariation+=swapLoopBody;
		}
	}
	loopStartFrom=parseInt((Math.random()-0.5)*20);
	if(Math.random()<difficultyThreshold){//εισαγωγή ΑΠΟ
		exerciseVariation+=loopFrom;
		blanksCounter++;
	}
	loopStepValue=1;
	if(Math.random()<difficultyThreshold){//βήμα<>1
		exerciseVariation+=loopStep;
		do{
			if((exerciseVariation & twoVariables)==twoVariables){
				loopStepValue=parseInt(Math.random()*5);
			}
			else{
				loopStepValue=parseInt(Math.random()*3);				
			}
				
		}while(loopStepValue==0);
		if(Math.random()<difficultyThreshold && (exerciseVariation & request_xStep)!=request_xStep){//εισαγωγή ΜΕ_ΒΗΜΑ
			exerciseVariation+=request_loopStep;
			blanksCounter++;
		}
	}
	if((exerciseVariation & twoVariables)!=twoVariables && xStep==2 && loopStartFrom % 2!=0){
		loopStartFrom++;
	}
	loopEndTo=loopStartFrom+9*loopStepValue;
	if((exerciseVariation & twoVariables)==twoVariables && xStep==1){
		loopEndTo=loopStartFrom+19*loopStepValue;
	}
	if(Math.random()<difficultyThreshold && (exerciseVariation & twoVariables)==twoVariables && (exerciseVariation & loopFrom)!=loopFrom && (exerciseVariation & loopStep)!=loopStep){
		exerciseVariation+=loopTo; //εισαγωγή ΜΕΧΡΙ - Προκειμένου να έχει η άσκηση μοναδική λύση, ζητείται από το χρήστη με την προϋπόθεση ότι χρησιμοποιείται και η x και δεν έχει ζητηθεί η ΑΠΟ
		blanksCounter++;
	}
	if(Math.random()<difficultyThreshold && (loopStepValue!=1 && (exerciseVariation & twoVariables)!=twoVariables) || ((exerciseVariation & twoVariables)==twoVariables && xStep==1)){//Δομή Επιλογής στην έξοδο μόν αν έχουμε περισσότερες από 10 επαναλήψεις
		exerciseVariation+=outputWithConditional;
		if(Math.random()<difficultyThreshold){//εισαγωγή Συνθήκης
			exerciseVariation+=request_OutputConditional;
			blanksCounter++;
		}
	}
	if((Math.random()<difficultyThreshold && ((exerciseVariation & twoVariables)!=twoVariables && ((exerciseVariation & loopFrom)!=loopFrom || (exerciseVariation & loopTo)!=loopTo))) || blanksCounter==0){
		exerciseVariation+=request_OutputExpression;//εισαγωγή έκφρασης εξόδου (παράμετρος ΓΡΑΨΕ) - ζητείται με την προϋπόθεση ότι χρησιμοποιείται μόνο η i και δεν έχει ζητηθεί τουλάχιστον μία από τις ΑΠΟ και ΜΕΧΡΙ 
		blanksCounter++;
	}	
}

function simulateCode(){
    if(simulationInitialise()){
        $("#btnContinue").hide();
        $("#btnForward").prop("disabled",true);
        $("#btnNewProblem").prop("disabled",true);
        $("#btnDelete").prop("disabled",true);
        $("#btnSubmit").prop("disabled",true);
        $("#btnShowSolution").prop("disabled",true);
        $("#btnPlay").hide();
        $("#btnPause").show();
        $("#btnStop").prop("disabled",false);
        $("#btnForward").prop("disabled",false);
        $("#showOptions").hide();
        //έναρξη προσομοίωσης με κλήση timer
        timerLoop=setInterval(function(){simulationRun();},simSpeed);
    }
}

function simulationInitialise(){
    var i=0;
    simulationInitialised=true;
    if(document.getElementById("xStart")){
        userValues[i]=trimSpaces(document.getElementById("xStart").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=xStart;
    }
    i++;
    if(document.getElementById("loopFrom")){
        userValues[i]=trimSpaces(document.getElementById("loopFrom").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=loopStartFrom;
    }
    i++;
    if(document.getElementById("loopTo")){
        userValues[i]=trimSpaces(document.getElementById("loopTo").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=loopEndTo;
    }
    i++;
    if(document.getElementById("loopStep")){
        userValues[i]=trimSpaces(document.getElementById("loopStep").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=loopStepValue;
    }
    i++;
    if(document.getElementById("xConditional")){
        userValues[i]=trimSpaces(document.getElementById("xConditional").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=xConditional;
    }
    i++;
    if(document.getElementById("iConditional")){
        userValues[i]=trimSpaces(document.getElementById("iConditional").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=iConditional;
    }
    i++;
    if(document.getElementById("xExpression")){
        userValues[i]=trimSpaces(document.getElementById("xExpression").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=xExpression;
    }
    i++;
    if(document.getElementById("iExpression")){
        userValues[i]=trimSpaces(document.getElementById("iExpression").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=iExpression[0];
    }
    i++;
    if(document.getElementById("xStep")){
        userValues[i]=trimSpaces(document.getElementById("xStep").innerHTML);
        if(userValues[i]=="")simulationInitialised=false;
    }
    else{
        userValues[i]=xStep;
    }
        
    loopBegin=parseFloat(userValues[1]);
    loopEnd=parseFloat(userValues[2]);
    /*if(loopBegin>loopEnd){
        loopBegin=parseFloat(userValues[2]);
        loopEnd=parseFloat(userValues[1]);
    }*/
    programOutput="";
    return simulationInitialised;
}

function simulationRun(){
    //Οι επόμενες 2 εντολές τοποθετούνται εδώ και όχι στην simulateCode
    // για να λειτουργεί σωστά και η βηματική εκτέλεση
    $("#resultsArea").show();
    $("#messageArea").hide();

    simulationIndex++;
    var jStart=1;
    var nxtSimulationIndex=simulationIndex;
    if(simulationIndex>codeLength){//Μετά την προσομοίωση της τελευταίας εντολής τερμάτισε το μηχανισμό προσομοίωσης
        simulationReset();
        return;
    }
    $(".simulatingCode").removeClass("simulatingCode");
    if(hideSimulationPath){
        jStart=simulationIndex+1;
    }
    //εμφάνιση μονοπατιού προσομοίωσης
    for(var j=jStart;j<=simulationIndex+1;j++){
        $("#cmd"+j).addClass("simulatingCode");
    }

    hideSimulationValues();

    if((exerciseVariation & twoVariables)==twoVariables){// i και x
        if((exerciseVariation & swapLoopBody)==swapLoopBody){//Πρώτα τροποποίησε
            switch (simulationIndex){
                case 0: //Αρχικοποίηση x
                    xSim=parseFloat(userValues[0]);
                    if(showVarValues){
                        $("#xStartVal").html(" x = "+xSim+" ");
                        $("#xStartVal").show(animationRate);
                    }

                    break;
                case 1: //Είσοδος στη Δομή Επανάληψης
                    var iCondVal="ΑΛΗΘΗΣ";
                    var iInitialisationInfo="";
                    if(!iInitialised){
                        iInitialised=true;
                        iSim=loopBegin;
                        iInitialisationInfo="i="+iSim+" , ";
                    }
                    if(iSim>loopEnd && parseFloat(userValues[3])>=0 || iSim<loopEnd && parseFloat(userValues[3])<0){
                        iCondVal="ΨΕΥΔΗΣ";
                        nxtSimulationIndex=4;//Ολοκλήρωση Δομής
                    }
                    if(showVarValues){
                        $("#iCond").html(" "+iInitialisationInfo+iSim+" <= "+loopEnd+" ["+iCondVal+"] ");
                        $("#iCond").show(animationRate);
                    }
                    break;
                case 2: //Υπολογισμός νέας τιμής x
                    xSim+=parseFloat(userValues[8]);
                    if(showVarValues){
                        $("#xVal").html(" x = "+xSim+" ");
                        $("#xVal").show(animationRate);
                    }
                    break;
                case 3: //ΓΡΑΨΕ
                    var debugInfo=" ";
                    if((exerciseVariation & outputWithConditional)==outputWithConditional){
                        outputConditional="ΨΕΥΔΗΣ";
                        var outputDebug="";
                        if(stringLogicalValue(userValues[4],xSim)){
                            outputConditional="ΑΛΗΘΗΣ";
                            outputSim=stringExpressionValue(userValues[6],xSim);
                            programOutput+=outputSim+" ";
                            outputDebug=" , ΟΘΟΝΗ: "+outputSim;
                        }
                        debugInfo+="Συνθήκη = "+outputConditional+outputDebug;
                    }
                    else{
                        outputSim=stringExpressionValue(userValues[6],xSim);
                        programOutput+=outputSim+" ";
                        debugInfo+="ΟΘΟΝΗ: "+outputSim;
                    }
                    if(showVarValues){
                        $("#output").html(debugInfo+" ");
                        $("#output").show(animationRate);
                    }
                    break;
                case 4: //ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ
                    iSim+=parseFloat(userValues[3]);
                    if(showVarValues){
                        $("#iVal").html(" i = "+iSim+" ");
                        $("#iVal").show(animationRate);
                    }
                    nxtSimulationIndex=0;
                    break;
            }
        }
        else{//πρώτα ΓΡΑΨΕ
            switch (simulationIndex){
                case 0: //Αρχικοποίηση x
                    xSim=parseFloat(userValues[0]);
                    if(showVarValues){
                        $("#xStartVal").html(" x = "+xSim+" ");
                        $("#xStartVal").show(animationRate);
                    }
                    break;
                case 1: //Είσοδος στη Δομή Επανάληψης
                    var iCondVal="ΑΛΗΘΗΣ";
                    var iInitialisationInfo="";
                    if(!iInitialised){
                        iInitialised=true;
                        iSim=loopBegin;
                        iInitialisationInfo="i = "+iSim+" , ";
                    }
                    if(iSim>loopEnd && parseFloat(userValues[3])>=0 || iSim<loopEnd && parseFloat(userValues[3])<0){
                        iCondVal="ΨΕΥΔΗΣ";
                        nxtSimulationIndex=4;//Ολοκλήρωση Δομής
                    }
                    if(showVarValues){
                        $("#iCond").html(" "+iInitialisationInfo+iSim+" <= "+loopEnd+" ["+iCondVal+"] ");
                        $("#iCond").show(animationRate);
                    }
                    break;
                case 2: //ΓΡΑΨΕ
                    var debugInfo=" ";
                    if((exerciseVariation & outputWithConditional)==outputWithConditional){
                        outputConditional="ΨΕΥΔΗΣ";
                        var outputDebug="";
                        if(stringLogicalValue(userValues[4],xSim)){
                            outputConditional="ΑΛΗΘΗΣ";
                            outputSim=stringExpressionValue(userValues[6],xSim);
                            programOutput+=outputSim+" ";
                            outputDebug=" , ΟΘΟΝΗ: "+outputSim;
                        }
                        debugInfo+="Συνθήκη = "+outputConditional+outputDebug;
                    }
                    else{
                        outputSim=stringExpressionValue(userValues[6],xSim);
                        programOutput+=outputSim+" ";
                        debugInfo+="ΟΘΟΝΗ: "+outputSim;
                    }
                    if(showVarValues){
                        $("#output").html(debugInfo+" ");
                        $("#output").show(animationRate);
                    }
                    break;
                case 3: //Υπολογισμός νέας τιμής x
                    xSim+=parseFloat(userValues[8]);
                    if(showVarValues){
                        $("#xVal").html(" x = "+xSim+" ");
                        $("#xVal").show(animationRate);
                    }
                    break;
                case 4: //ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ
                    iSim+=parseFloat(userValues[3]);
                    if(showVarValues){
                        $("#iVal").html(" i = "+iSim+" ");
                        $("#iVal").show(animationRate);
                    }
                    nxtSimulationIndex=0;
                    break;
            }
        }
    }
    else{//μόνο i
        if((exerciseVariation & swapLoopBody)==swapLoopBody){//Πρώτα τροποποίησε
            //ΔΕ ΜΠΟΡΕΙ ΝΑ ΣΥΜΒΕΙ!!!
        }
        else{//πρώτα ΓΡΑΨΕ
            switch (simulationIndex){
                case 0: //Είσοδος στη Δομή Επανάληψης
                    var iCondVal="ΑΛΗΘΗΣ";
                    var iInitialisationInfo="";
                    if(!iInitialised){
                        iInitialised=true;
                        iSim=loopBegin;
                        iInitialisationInfo="i = "+iSim+" , ";
                    }
                    if(iSim>loopEnd && parseFloat(userValues[3])>=0 || iSim<loopEnd && parseFloat(userValues[3])<0){
                        iCondVal="ΨΕΥΔΗΣ";
                        nxtSimulationIndex=2;//Ολοκλήρωση Δομής
                    }
                    if(showVarValues){
                        $("#iCond").html(" "+iInitialisationInfo+iSim+" <= "+loopEnd+" ["+iCondVal+"] ");
                        $("#iCond").show(animationRate);
                    }
                    break;
                case 1: //ΓΡΑΨΕ
                    var debugInfo=" ";
                    if((exerciseVariation & outputWithConditional)==outputWithConditional){
                        outputConditional="ΨΕΥΔΗΣ";
                        var outputDebug="";
                        if(stringLogicalValue(userValues[5],iSim)){
                            outputConditional="ΑΛΗΘΗΣ";
                            outputSim=stringExpressionValue(userValues[7],iSim);
                            programOutput+=outputSim+" ";
                            outputDebug=" , ΟΘΟΝΗ: "+outputSim;
                        }
                        debugInfo+="Συνθήκη = "+outputConditional+outputDebug;
                    }
                    else{
                        outputSim=stringExpressionValue(userValues[7],iSim);
                        programOutput+=outputSim+" ";
                        debugInfo+="ΟΘΟΝΗ: "+outputSim;
                    }
                    if(showVarValues){
                        $("#output").html(debugInfo+" ");
                        $("#output").show(animationRate);
                    }
                    break;
                case 2: //ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ
                    iSim+=parseFloat(userValues[3]);
                    if(showVarValues){
                        $("#iVal").html(" i = "+iSim+" ");
                        $("#iVal").show(animationRate);
                    }
                    nxtSimulationIndex=-1;
                    break;
            }            
        }
    }
    simulationIndex=nxtSimulationIndex;
    document.getElementById("studentResults").innerHTML="<span id='resultsTitle'>Αποτελέσματα εκτέλεσης</span><br><code>"+programOutput+"</code>";
    
    /*$("#studentResults").show(jQueryAnimationRate,function(){
        sizeDIVs();
    });*/    
    $("#studentResults").show();
}

function simulationReset(){
    clearInterval(timerLoop);
    $("#btnNewProblem").prop("disabled",false);
    $("#btnDelete").prop("disabled",false);
    $("#btnSubmit").prop("disabled",false);
    $("#btnShowSolution").prop("disabled",false);
    $(".simulatingCode").removeClass("simulatingCode");
    $("#btnContinue").hide();
    $("#btnForward").prop("disabled",false);
    $("#btnPlay").show();
    $("#btnPause").hide();
    $("#btnStop").prop("disabled",true);
    $("#showOptions").show();
    simulationIndex=-1;
    iInitialised=false;
    hideSimulationValues();
    simulationInitialised=false;
}

function hideSimulationValues(){
    if(!showVarValues || simulationIndex!=0){
        $("#xStartVal").html("");
        $("#xStartVal").hide(animationRate);
    }
    if(!showVarValues || simulationIndex<1 || simulationIndex>=codeLength){
        $("#iCond").html("");
        $("#iCond").hide(animationRate);
        
        $("#iVal").html("");
        $("#iVal").hide(animationRate);
    }
    if(!showVarValues || simulationIndex!=outputIndex){
        $("#output").html("");
        $("#output").hide(animationRate);
    }
    if(!showVarValues || simulationIndex!=generateNewValueIndex){
        $("#xVal").html("");
        $("#xVal").hide(animationRate);
    }
}

function generateForLoop(){
	var lineNo=0;
	var code="";
	//Αν χρησιμοποιείται η x, αρχικοποίησέ την
	if((exerciseVariation & twoVariables)==twoVariables){
		lineNo++;
		if((exerciseVariation & request_xStart) == request_xStart){
			code+="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'> x <- "+generateEntryPlaceholder("xStart")+"</span>";
		}
		else{
			code+="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'> x <- "+xStart+"</span>";
		}
        code+="   <span class='showValues' id='xStartVal'></span>";
	}
	
	//τιμή ΑΠΟ
	lineNo++;
	var fromValue="";
	if((exerciseVariation & loopFrom) == loopFrom){
		fromValue=generateEntryPlaceholder("loopFrom");
	}
	else{
		fromValue=loopStartFrom;
	}
	code+="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'> <span class='reservedWord'>ΓΙΑ</span> i <span class='reservedWord'>ΑΠΟ</span> "+fromValue;
	
	//τιμή ΜΕΧΡΙ
	var toValue="";
	if((exerciseVariation & loopTo) == loopTo){
		toValue=generateEntryPlaceholder("loopTo");
	}
	else{
		toValue=loopEndTo;
	}
	code+=" <span class='reservedWord'>ΜΕΧΡΙ</span> "+toValue;

	//τιμή ΜΕ_ΒΗΜΑ
	var stepValue="";
	if((loopStepValue!=1 && exerciseVariation & loopStep) == loopStep){
		if((exerciseVariation & request_loopStep) == request_loopStep){
			stepValue=generateEntryPlaceholder("loopStep");
		}
		else{
			stepValue=loopStepValue;
		}		
		code+=" <span class='reservedWord'>ΜΕ_ΒΗΜΑ</span> "+stepValue;
	}
	code+="</span>   <span class='showValues' id='iCond'></span>";
	
	//σώμα Δομής Επανάληψης
	if((exerciseVariation & swapLoopBody) == swapLoopBody){
		code+=generateOtherCommand();
		code+=generateOutput();
	}
	else{
		code+=generateOutput();
		code+=generateOtherCommand();
	}
	lineNo++;
	code+="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'> <span class='reservedWord'>ΤΕΛΟΣ_ΕΠΑΝΑΛΗΨΗΣ</span></span>   <span class='showValues' id='iVal'></span>";
	codeLength=lineNo;
	return code;

	function generateOutput(){
	    lineNo++;
	    outputIndex=lineNo-1;
		var code="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'>   ";
		//Προσθήκη Δομής Επιλογής
		if((exerciseVariation & outputWithConditional) == outputWithConditional){
			var conditional="";
			//Αν η έξοδος γίνει με ΔΟΜΗ ΕΠΙΛΟΓΗΣ...
			if((exerciseVariation & request_OutputConditional) == request_OutputConditional){
				if((exerciseVariation & twoVariables) == twoVariables){
					conditional=generateEntryPlaceholder("xConditional");
				}
				else{
					conditional=generateEntryPlaceholder("iConditional");
				}
			}
			else{
				if((exerciseVariation & twoVariables) == twoVariables){
					conditional="x MOD 2 = 0";
				}
				else{
					conditional="i MOD 2 = 0";
				}
			}
			code+="<span class='reservedWord'>ΑΝ</span> "+conditional+" <span class='reservedWord'>ΤΟΤΕ</span> ";
		}
		
		//Εντολή εξόδου
		var outputExpression="";
		if((exerciseVariation & twoVariables) == twoVariables){
			//Προετοιμασία xExpression
			var dx=xStart;
			if((exerciseVariation & swapLoopBody) == swapLoopBody){
				dx+=xStep;
			}
			xExpression="x";
			if(dx!=0){
				if(dx % 2 != 0) dx++;
				if(dx>0){
					xExpression+="-";
				}
				else{
					xExpression+="+";
				}
				xExpression+=Math.abs(dx);
			}
			outputExpression=xExpression;
		}
		else{
			//Προετοιμασία iExpression
			if(loopStepValue==1 && loopEndTo-loopStartFrom==9){
				var iExprConstruction1="2 * i";
				var iExprConstruction2="2 * (i";
				var iExprConstruction3="i * 2";
				var iExprConstruction4="(i";
				if(loopStartFrom>0){
					iExprConstruction1+=" - "+2*loopStartFrom;
					iExprConstruction2+=" - "+loopStartFrom+")";
					iExprConstruction3+=" - "+2*loopStartFrom;
					iExprConstruction4+=" - "+loopStartFrom+") * 2";
				}
				else if(loopStartFrom<0){
					iExprConstruction1+=" + "+2*Math.abs(loopStartFrom);
					iExprConstruction2+=" + "+Math.abs(loopStartFrom)+")";
					iExprConstruction3+=" + "+2*Math.abs(loopStartFrom);
					iExprConstruction4+=" + "+Math.abs(loopStartFrom)+") * 2";
				}
				else{
					iExprConstruction2="i * 2";
					iExprConstruction3="2 * i";
					iExprConstruction4=iExprConstruction2;
				}
			}
			else{
				var iOffset="";
				if(loopStartFrom>0){
					iOffset=" - "+loopStartFrom;
				}
				else if(loopStartFrom<0){
					iOffset=" + "+Math.abs(loopStartFrom);
				}
				iExprConstruction1="i"+iOffset;
				iExprConstruction2="i"+iOffset;
				iExprConstruction3="i"+iOffset;
				iExprConstruction4="i"+iOffset;
			}
			iExpression=[iExprConstruction1,iExprConstruction2,iExprConstruction3,iExprConstruction4];

			if(Math.random()<0.25){
				outputExpression=iExprConstruction1;
			}
			else if(Math.random()<0.5){
				outputExpression=iExprConstruction2;
			}
			else if(Math.random()<0.75){
				outputExpression=iExprConstruction3;
			}
			else{
				outputExpression=iExprConstruction4;
			}
		}
		if((exerciseVariation & request_OutputExpression) == request_OutputExpression){
			if((exerciseVariation & twoVariables) == twoVariables){
				outputExpression=generateEntryPlaceholder("xExpression");
			}
			else{
				outputExpression=generateEntryPlaceholder("iExpression");
			}
		}
		code+="<span class='reservedWord'>ΓΡΑΨΕ</span> "+outputExpression+"</span>   <span class='showValues' id='output'></span>";
		return code;
	}

	function generateOtherCommand(){
		var code="";
		if((exerciseVariation & twoVariables) == twoVariables){
			lineNo++;
			generateNewValueIndex=lineNo-1;
			if((exerciseVariation & request_xStep) == request_xStep){
				code+="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'>   x <- x + "+generateEntryPlaceholder("xStep");
			}
			else{
				code+="\n"+lineNo+":<span class='algoCmd' id='cmd"+lineNo+"'>   x <- x + "+xStep;
			}
			code+="</span>   <span class='showValues' id='xVal'></span>";
		}
		return code;
	}
}

function checkSolution(){
	$("#solutionOk").hide();
	$("#solutionError").hide();
	userOutputVisible=false;
	$("#studentResults").hide(0,function(){
		sizeDIVs();
	});
	if(userSolutionOK()){
		if(debug)alert("Εύγε!!!!");
		$("#btnHint").prop("disabled",true);
		$("#solutionOk").show(jQueryAnimationRate);
		$("#btnPlay").prop("disabled",false);
		$("#btnForward").prop("disabled",false);
	}
	else{
		$("#solutionError").show(jQueryAnimationRate);
		$("#btnHint").prop("disabled",false);
		$("#btnPlay").prop("disabled",true);
		$("#btnForward").prop("disabled",true);
		var msg="Την πάτησες...";
		if(debug)alert(msg);
	}
}

function userSolutionOK(){
	var solutionOK=true;
	clearHint();
	//έλεγχος εγκυρότητας και εξαγωγή τιμών χρήστη
	errorLocation=noSyntaxError;
	for(var i=0;i<userEntriesIDs.length;i++){
		if(document.getElementById(userEntriesIDs[i])){
			userValues[i]=trimSpaces(document.getElementById(userEntriesIDs[i]).textContent);
			if(checkEntry(userValues[i],entryTypes[i])){
				if(entryTypes[i]==numericEntry) userValues[i]=parseFloat(userValues[i]);
			}
			else{
				errorLocation+=errorCodes[i];
			}
		}
	}
	solutionOK=(errorLocation==noSyntaxError);
	switch(difficultyLevel){
	case 0:
	case 1:
	case 2:
		if(loopEndTo!=trimSpaces(userValues[2].toString().toLowerCase())){
			solutionOK=false;
			logicalErrors="<p>Η τιμή λήξης της Δομής Επανάληψης πρέπει να είναι <span class='correctValue'>"+loopEndTo+"</span>";
			if(userValues[2]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[2]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		break;
	case 3:
		if(xStart!=trimSpaces(userValues[0].toString().toLowerCase())){
			solutionOK=false;
			logicalErrors="<p>Η αρχική τιμή του x πρέπει να είναι <span class='correctValue'>"+xStart+"</span>";
			if(userValues[0]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[0]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		break;
	case 4:
	case 5:
		var userVal=trimSpaces(userValues[7].toString().toLowerCase());
		if(iExpression[0]!=userVal && iExpression[1]!=userVal && iExpression[2]!=userVal && iExpression[3]!=userVal){
			solutionOK=false;
			logicalErrors="<p>Η παράμετρος στην Εντολή <code>ΓΡΑΨΕ</code> πρέπει να είναι <span class='correctValue'>"+iExpression[0]+"</span>";
			if(userValues[7]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[7]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		break;
	case 6:
		if(trimSpaces(iConditional.toLowerCase())!=trimSpaces(userValues[5].toString().toLowerCase())){
			solutionOK=false;
			logicalErrors="<p>Η συνθήκη της Δομής Επιλογής πρέπει να είναι <span class='correctValue'>"+iConditional+"</span>";
			if(userValues[5]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[5]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		break;
	case 7:
		if(xStep!=trimSpaces(userValues[8].toString().toLowerCase())){
			solutionOK=false;
			logicalErrors="<p>Η τιμή μεταβολής του x πρέπει να είναι <span class='correctValue'>"+xStep+"</span>";
			if(userValues[8]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[8]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		break;
	case 8:
		if(loopStepValue!=trimSpaces(userValues[3].toString().toLowerCase())){
			solutionOK=false;
			logicalErrors="<p>Η τιμή του βήματος της Δομής Επανάληψης πρέπει να είναι <span class='correctValue'>"+loopStepValue+"</span>";
			if(userValues[3]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[3]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		var userVal=trimSpaces(userValues[7].toString().toLowerCase());
		if(iExpression[0]!=userVal && iExpression[1]!=userVal && iExpression[2]!=userVal && iExpression[3]!=userVal){
			solutionOK=false;
			logicalErrors+="<p>Η παράμετρος στην Εντολή <code>ΓΡΑΨΕ</code> πρέπει να είναι <span class='correctValue'>"+iExpression[0]+"</span>";
			if(userValues[7]!=""){
			    logicalErrors+=" και όχι <span class='errorValue'>"+userValues[7]+"</span>.</p>";
			}
			else{
			    logicalErrors+=".</p>";
			}
		}
		break;
	case 9:
		solutionOK=checkRandomExercise();
		break;
	}
	return solutionOK;
}

function checkEntry(userEntry,entryType){
	var comparatorPosition=-1;
	var entryOK=true;
	var lessThanAllowed=true;
	var greaterThanAllowed=true;
	var equalAllowed=true;
	var lng=userEntry.length;
	var i=0;
	if(lng==0)entryOK=false;
	if(entryType==conditionalEntry){
		entryOK=!(trimSpaces(userEntry).toLowerCase()!=trimSpaces(iConditional.toLowerCase()) && trimSpaces(userEntry).toLowerCase()!=trimSpaces(xConditional.toLowerCase()));
	}
	else if(entryType==expressionEntry){
		entryOK=!(trimSpaces(userEntry).toLowerCase()!=trimSpaces(iExpression[0].toLowerCase()) && trimSpaces(userEntry).toLowerCase()!=trimSpaces(iExpression[1].toLowerCase()) && trimSpaces(userEntry).toLowerCase()!=trimSpaces(iExpression[2].toLowerCase()) && trimSpaces(userEntry).toLowerCase()!=trimSpaces(iExpression[3].toLowerCase()));
	}
	else{
		while(entryOK && i<lng){
			currentChar=userEntry.charAt(i);
			if((entryType & numericEntry)!=0){//Έλεγχος αριθμητικών ψηφίων
				if(currentChar>="0" && currentChar<="9" || currentChar=="+" || currentChar=="-"){//αριθμητικά ψηφία και πρόσημα είναι δεκτά
					if((entryType & comparatorEntry)!=0){//Ο συγκριτικός τελεστής πρέπει να ολοκληρώνεται πριν την αριθμητική τιμή
						entryType-=comparatorEntry;
					}
				}
				else if(entryType==numericEntry){//οποιοσδήποτε άλλος χαρακτήρας απορρίπτεται εφόσον αναζητούμε μόνο αριθμό
					entryOK=false;
				}
			}
			if(entryOK && (entryType & comparatorEntry)!=0){//Έλεγχος συγκριτικών τελεστών
				if(i==comparatorPosition+1){//Συγκριτικοί Τελεστές επιτρέπονται μόνο σε διαδοχικές αρχικές θέσεις
					comparatorPosition=i;
					switch(currentChar){
					case "<":
						if(lessThanAllowed){
							userComparator+=currentChar;
							lessThanAllowed=false;
						}
						else{
							entryOK=false;
						}
						break;
					case "=":
						if(equalAllowed){
							userComparatorType=comparatorWithEquality;
							userComparator+=currentChar;
							lessThanAllowed=false;
							greaterThanAllowed=false;
							equalAllowed=false;
						}
						else{
							entryOK=false;
						}
						break;
					case ">":
						if(greaterThanAllowed){
							userComparator+=currentChar;
							lessThanAllowed=false;
							greaterThanAllowed=false;
						}
						else{
							entryOK=false;
						}
						break;//επιτρέπονται σύμβολα συγκριτικών χαρακτήρων της ψευδογλώσσας
					default://οποιοσδήποτε άλλος χαρακτήρας απορρίπτεται
						entryOK=false;
					}
				}
				else{
					entryOK=false;
				}
			}
			/*if(entryOK && entryType==textEntry){//Έλεγχος αλφαβητικών χαρακτήρων
				if(currentChar>="α" && currentChar<="ω" || currentChar=="x"){
					//επιτρέπονται ελληνικά πεζά και το λατινικό x
				}
				else{
					entryOK=false;
				}
			}*/
			i++;
		}
	}
	return entryOK;
}

function trimSpaces(entry){
	var currentChar="",correctedChar="";
	var entryLength=entry.length;
	var trimmed="";
	for(var i=0;i<entryLength;i++){
		currentChar=entry.charAt(i);
		if(currentChar!=" " && currentChar!="ˍ"){
			switch(currentChar){
			case "΅":
				correctedChar="";
				break;
			case "Ά":
			case "ά":
				correctedChar="α";
				break;
			case "Έ":
			case "έ":
				correctedChar="ε";
				break;
			case "Ή":
			case "ή":
				correctedChar="η";
				break;
			case "Ί":
			case "ί":
			case "Ϊ":
			case "ϊ":
			case "ΐ":
				correctedChar="ι";
				break;
			case "Ύ":
			case "ύ":
			case "Ϋ":
			case "ϋ":
			case "ΰ":
				correctedChar="υ";
				break;
			case "Ώ":
			case "ώ":
				correctedChar="ω";
				break;
			case "Ό":
			case "ό":
			case "ο":
				correctedChar="o";//aggliko
				break;
			case "Χ":
			case "χ":
				correctedChar="x";
				break;
			default:
				correctedChar=currentChar.toLowerCase();
			}
			trimmed+=correctedChar;
		}
	}
	return trimmed;
}

function checkRandomExercise(){
	var solutionOK=true;
	var msg="";
	var i=0;
	if(document.getElementById("xStart")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=xStart.toString().toLowerCase()){
			solutionOK=false;
			msg+="<p>Η αρχική τιμή του x πρέπει να είναι <span class='correctValue'>"+xStart+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("loopFrom")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=loopStartFrom.toString().toLowerCase()){
			solutionOK=false;
			msg+="<p>Η τιμή έναρξης της Δομής Επανάληψης πρέπει να είναι <span class='correctValue'>"+loopStartFrom+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("loopTo")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=loopEndTo.toString().toLowerCase()){
			solutionOK=false;
			msg+="<p>Η τιμή λήξης της Δομής Επανάληψης πρέπει να είναι <span class='correctValue'>"+loopEndTo+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("loopStep")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=loopStepValue.toString().toLowerCase()){
			solutionOK=false;
			msg+="<p>Η τιμή του βήματος της Δομής Επανάληψης πρέπει να είναι <span class='correctValue'>"+loopStepValue+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("xConditional")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=trimSpaces(xConditional.toLowerCase())){
			solutionOK=false;
			msg+="<p>Η συνθήκη της Δομής Επιλογής πρέπει να είναι <span class='correctValue'>"+xConditional+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("iConditional")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=trimSpaces(iConditional.toLowerCase())){
			solutionOK=false;
			msg+="<p>Η συνθήκη της Δομής Επιλογής πρέπει να είναι <span class='correctValue'>"+iConditional+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("xExpression")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=trimSpaces(xExpression.toLowerCase())){
			solutionOK=false;
			msg+="<p>Η παράμετρος στην Εντολή <code>ΓΡΑΨΕ</code> πρέπει να είναι <span class='correctValue'>"+xExpression+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("iExpression")){
		var userVal=trimSpaces(userValues[i].toString().toLowerCase());
		if(userVal!=trimSpaces(iExpression[0].toLowerCase()) && userVal!=trimSpaces(iExpression[1].toLowerCase())  && userVal!=trimSpaces(iExpression[2].toLowerCase())  && userVal!=trimSpaces(iExpression[3].toLowerCase())){
			solutionOK=false;
			msg+="<p>Η παράμετρος στην Εντολή <code>ΓΡΑΨΕ</code> πρέπει να είναι <span class='correctValue'>"+iExpression[0]+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	i++;
	if(document.getElementById("xStep")){
		if(trimSpaces(userValues[i].toString().toLowerCase())!=xStep.toString().toLowerCase()){
			solutionOK=false;
			msg+="<p>Η τιμή μεταβολής του x πρέπει να είναι <span class='correctValue'>"+xStep+"</span>";
			if(userValues[i]!=""){
			    msg+=" και όχι <span class='errorValue'>"+userValues[i]+"</span>.</p>";
			}
			else{
			    msg+=".</p>";
			}
		}
	}
	logicalErrors=msg;
	return solutionOK;
}

function deleteAll(){
	for(var i=0;i<userEntriesIDs.length;i++){
		if(document.getElementById(userEntriesIDs[i])){
			document.getElementById(userEntriesIDs[i]).innerHTML="ˍˍˍ";
		}
	}
	$("#btnHint").prop("disabled",true);
	$("#solutionOk").hide();
	$("#solutionError").hide();
	$("#btnPlay").prop("disabled",true);
	$("#btnForward").prop("disabled",true);
	solutionOutputVisible=false;
	$("#originalResults").hide();
	userOutputVisible=false;
	$("#studentResults").hide();
	clearHint();
	hideResult();
	sizeDIVs();
}

function showHint(){
	hintLevel++;
	var msg="";
	if(hintLevel>-1){
		for(var i=0;i<userEntriesIDs.length;i++){
			if((errorLocation & errorCodes[i])===errorCodes[i]){
				msg+="<p>"+syntaxError[i]+"</p>";
			}
		}
	}
	if(msg==""){
		hintLevel++;
	}
	if(hintLevel>0){
		msg+=logicalErrors;
	}
	document.getElementById("hintToShow").innerHTML=msg;
	if(hintLevel>1){
		simulateCode();
	}
    $("#resultsArea").hide();
    if(msg==""){
        $("#messageArea").hide();
    }
    else{
        $("#messageArea").show();
    }
}

function infinitySymbol(value){
	if(value==Infinity){
		return "∞";
	}
	else if(value==-Infinity){
		return "-∞";
	}
	else{
		return value;
	}
}

function clearHint(){
	hintLevel=-1;
	document.getElementById("hintToShow").innerHTML="";
	showUnion=false;
}

function hideHint(){
	$("#btnHint").prop("disabled",true);
	$("#messageArea").hide();
}

function hideResult(){
	$("#solutionOk").hide();
	$("#solutionError").hide();
}

function showSolution(){
    if(requestConfirmationState || confirm("Θέλεις σίγουρα να αποκαλύψεις μία λύση;")){
        $("#btnPlay").prop("disabled",false);
        $("#btnForward").prop("disabled",false);
        iExpressionSelector=(iExpressionSelector+1) % iExpression.length;//εναλλαγή τιμής
        switch(difficultyLevel){
        case 0:
        case 1:
        case 2:
            document.getElementById("loopTo").innerHTML=loopEndTo;
            break;
        case 3:
            document.getElementById("xStart").innerHTML=xStart;
            break;
        case 4:
        case 5:
            document.getElementById("iExpression").innerHTML=iExpression[iExpressionSelector];
            break;
        case 6:
            document.getElementById("iConditional").innerHTML=iConditional;
            break;
        case 7:
            document.getElementById("xStep").innerHTML=xStep;
            break;
        case 8:
            document.getElementById("loopStep").innerHTML=loopStepValue;
            document.getElementById("iExpression").innerHTML=iExpression[0];
            break;
        case 9:
            if(document.getElementById("xStart")){
                document.getElementById("xStart").innerHTML=xStart;
            }
            if(document.getElementById("loopFrom")){
                document.getElementById("loopFrom").innerHTML=loopStartFrom;
            }
            if(document.getElementById("loopTo")){
                document.getElementById("loopTo").innerHTML=loopEndTo;
            }
            if(document.getElementById("loopStep")){
                document.getElementById("loopStep").innerHTML=loopStepValue;
            }
            if(document.getElementById("xConditional")){
                document.getElementById("xConditional").innerHTML="x MOD 2 = 0";
            }
            if(document.getElementById("iConditional")){
                document.getElementById("iConditional").innerHTML="i MOD 2 = 0";
            }
            if(document.getElementById("xExpression")){
                document.getElementById("xExpression").innerHTML=xExpression;//"2";
            }
            if(document.getElementById("iExpression")){
                document.getElementById("iExpression").innerHTML=iExpression[iExpressionSelector];
            }
            if(document.getElementById("xStep")){
                document.getElementById("xStep").innerHTML=xStep;
            }
            break;
        }
        
        $("#btnHint").prop("disabled",true);
        solutionOutputVisible=false;
        $("#originalResults").hide();
        userOutputVisible=false;
        $("#studentResults").hide();
        clearHint();
        hideResult();
        sizeDIVs();        
    }
}

function defineExerciseTypes(){
	var exerciseType=1;
	//determineNoOfRepetitions=exerciseType;
	
	twoVariables=exerciseType;
	exerciseType*=2;
	request_xStart=exerciseType;
	exerciseType*=2;
	request_xStep=exerciseType;
	exerciseType*=2;
	swapLoopBody=exerciseType;
	exerciseType*=2;
	loopVarExpression=exerciseType;
	exerciseType*=2;
	loopFrom=exerciseType;
	exerciseType*=2;
	loopTo=exerciseType;
	exerciseType*=2;
	loopStep=exerciseType;
	exerciseType*=2;
	request_loopStep=exerciseType;
	exerciseType*=2;
	outputWithConditional=exerciseType;
	exerciseType*=2;
	request_OutputConditional=exerciseType;
	exerciseType*=2;
	request_OutputExpression=exerciseType;
	exerciseType*=2;
}

function showAppID(){
	window.open("index_DS_II.html","_newtab");
}

function hideHelp(){
	$("#openModalHelp").hide();
}

function showHelp(){
    var availableHeight=window.innerHeight-48;
    if(availableHeight>100){
        $("#openModalHelp").show();
        $("#helpContent").css("height","auto");        
        var maxHeight=$("#helpContent").height();
        var heightToUse=availableHeight<maxHeight?availableHeight:maxHeight;
        $("#helpContent").height(heightToUse);
    }
    else{
        alert("Δεν υπάρχει αρκετός διαθέσιμος χώρος για εμφάνιση του παράθυρου βοήθειας. Παρακαλώ μεγαλώστε το παράθυρο και δοκιμάστε ξανά.");
    }
}